## GNS-2000%28GPL%29_2009-11-02.zip

=== Makefile ===
############################################################################
#Makefile on the top folder

ROOTDIR  = $(shell pwd)
LINUXDIR = $(ROOTDIR)/linux-2.6.12
IMAGEDIR = $(ROOTDIR)/images
RAMDISK  = $(IMAGEDIR)/romdisk
KERNELZ  = $(IMAGEDIR)/uImage
ROMFSDIR = $(ROOTDIR)/ramdisk
MAKEARCH = make
TFTPDIR	 = /tftpboot
DIRS	 = source

include $(ROOTDIR)/$(DIRS)/diff.mk

IMAGEDIR = $(ROOTDIR)/images-levelone

COPY_TO_TFTP = n
	
.PHONY: source
source:
	$(MAKEARCH) -C source all
	
.PHONY: ramdisk
ramdisk:
	rm -fr $(ROMFSDIR)
	tar xvfz $(ROOTDIR)/ram-neu.tgz
	for dir in $(DIRS) ; do $(MAKEARCH) -C $$dir install || exit 1 ; done
	chown root.root $(ROOTDIR)/ramdisk -R
	chmod ug+s $(ROOTDIR)/ramdisk/bin/tinylogin
	rm -f $(ROOTDIR)/ramdisk/home/httpd/html/Thumbs.db
	rm -f $(ROOTDIR)/ramdisk/home/httpd/html/Management/Thumbs.db
	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/Management/
#	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/Management/help
	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/Down 2>/dev/null
#	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/Down/.help	2>/dev/null	
	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/Files
#	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/Files/.help
	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/Photo
	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/help
	chmod 711 $(ROOTDIR)/ramdisk/home/httpd/html/langs
	chmod 600 $(ROOTDIR)/ramdisk/usr/stunnel/stunnel.pem
.PHONY: image

image: ramdisk
	[ -d $(IMAGEDIR) ] || mkdir -p $(IMAGEDIR)
	./mksquashfs $(ROMFSDIR) $(RAMDISK) -le -noI -no-fragments -noappend -lzma 
	rm -fr $(ROMFSDIR)

	@echo "+----------------------------------------------------"
	@echo "| Build Complete "
	@echo "|"
	@if [ "$(COPY_TO_TFTP)" = "y" ]; \
	then \
		if [ -d $(TFTPDIR) ]; \
		then \
			cp $(KERNELZ) $(TFTPDIR) ; \
			chmod a+r $(RAMDISK); cp $(RAMDISK) $(TFTPDIR) ; \
		fi \
	else \
		echo "| Images are in $(IMAGEDIR) " ; \
		echo "|" ; \
		echo "| As root, copy the images to /tftpboot " ; \
	fi
	@echo "+-----------------------------------------------------"

gpl-image: ramdisk
	[ -d $(IMAGEDIR) ] || mkdir -p $(IMAGEDIR)
	./mksquashfs $(ROMFSDIR) $(RAMDISK) -le -noI -no-fragments -noappend -lzma 
	tar -cvzf ram-gpl.tgz ramdisk
	rm -rf $(ROMFSDIR)
	@echo "+----------------------------------------------------"
	@echo "| Build Complete "
	@echo "|"
	@if [ "$(COPY_TO_TFTP)" = "y" ]; \
	then \
		if [ -d $(TFTPDIR) ]; \
		then \
			cp $(KERNELZ) $(TFTPDIR) ; \
			chmod a+r $(RAMDISK); cp $(RAMDISK) $(TFTPDIR) ; \
		fi \
	else \
		echo "| Images are in $(IMAGEDIR) " ; \
		echo "|" ; \
		echo "| As root, copy the images to /tftpboot " ; \
	fi
	@echo "+-----------------------------------------------------"
.PHONY: linux
linux linux%_only:
	$(MAKEARCH) -C $(LINUXDIR) uImage || exit 1
	$(MAKEARCH) -C $(LINUXDIR) modules || exit 1
	cp -f $(LINUXDIR)/arch/arm/boot/uImage $(KERNELZ)
dep:
	@if [ ! -f $(LINUXDIR)/.config ] ; then \
		echo "ERROR: you need to do a 'make config' first" ; \
		exit 1 ; \
	fi
	$(MAKEARCH) -C $(LINUXDIR) dep
copy:
	sudo chmod a+r $(IMAGEDIR)/ramdisk
	cp $(IMAGEDIR)/uImage /tftpboot -a
	cp $(IMAGEDIR)/ramdisk /tftpboot -a

clean: 
	for dir in $(LINUXDIR) $(DIRS); do $(MAKEARCH) -C $$dir clean ; done
	rm -rf $(ROMFSDIR)/*
#End of Makefile

=== linux-2.6.12/Makefile ===
VERSION = 2
PATCHLEVEL = 6
SUBLEVEL = 12
EXTRAVERSION = .6-arm1
NAME=Woozy Numbat

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
# 
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
.PHONY: _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

.PHONY: $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT)		\
	KBUILD_SRC=$(CURDIR)	     KBUILD_VERBOSE=$(KBUILD_VERBOSE)	\
	KBUILD_CHECK=$(KBUILD_CHECK) KBUILD_EXTMOD="$(KBUILD_EXTMOD)"	\
        -f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
.PHONY: all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)

export srctree objtree VPATH TOPDIR

nullstring :=
space      := $(nullstring) # end of line

# Take the contents of any files called localversion* and the config
# variable CONFIG_LOCALVERSION and append them to KERNELRELEASE. Be
# careful not to include files twice if building in the source
# directory. LOCALVERSION from the command line override all of this

localver := $(objtree)/localversion* $(srctree)/localversion*
localver := $(sort $(wildcard $(localver)))
# skip backup files (containing '~')
localver := $(foreach f, $(localver), $(if $(findstring ~, $(f)),,$(f)))

LOCALVERSION = $(subst $(space),, \
	       $(shell cat /dev/null $(localver)) \
	       $(patsubst "%",%,$(CONFIG_LOCALVERSION)))

KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)$(LOCALVERSION)

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and 
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# #CROSS_COMPILE specify the prefix used for all executables usedi
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(#CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

ARCH		?= arm
#CROSS_COMPILE	?= arm-linux-
#CROSS_COMPILE=arm-none-linux-gnueabi-
CROSS_COMPILE=../arm-linux-gnueabi/bin/arm-linux-gnueabi-

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC  	= gcc
HOSTCXX  	= g++
HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS	= -O2

# 	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN KBUILD_VERBOSE
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed. 
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's usefull
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE

######
# cc support functions to be used (only) in arch/$(ARCH)/Makefile
# See documentation in Documentation/kbuild/makefiles.txt

# cc-option
# Usage: cflags-y += $(call gcc-option, -march=winchip-c6, -march=i586)

cc-option = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
             > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

# For backward compatibility
check_gcc = $(warning check_gcc is deprecated - use cc-option) \
            $(call cc-option, $(1),$(2))

# cc-option-yn
# Usage: flag := $(call cc-option-yn, -march=winchip-c6)
cc-option-yn = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
                > /dev/null 2>&1; then echo "y"; else echo "n"; fi;)

# cc-option-align
# Prefix align with either -falign or -malign
cc-option-align = $(subst -functions=0,,\
	$(call cc-option,-falign-functions=0,-malign-functions=0))

# cc-version
# Usage gcc-ver := $(call cc-version $(CC))
cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh \
              $(if $(1), $(1), $(CC)))


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# For maximum performance (+ possibly random breakage, uncomment
# the following)

#MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := -Iinclude \
                   $(if $(KBUILD_SRC),-Iinclude2 -I$(srctree)/include)

CPPFLAGS        := -D__KERNEL__ $(LINUXINCLUDE)

CFLAGS 		:= -Wall -Wstrict-prototypes -Wno-trigraphs \
	  	   -fno-strict-aliasing -fno-common \
		   -ffreestanding
AFLAGS		:= -D__ASSEMBLY__

export	VERSION PATCHLEVEL SUBLEVEL EXTRAVERSION LOCALVERSION KERNELRELEASE \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE 
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# The temporary file to save gcc -MD generated dependencies must not
# contain a comma
comma := ,
depfile = $(subst $(comma),_,$(@D)/.$(@F).d)

=== source/Makefile ===
include diff.mk

#========================================================
# DIFF_DIR
DIFF_DIR    :=  diff/$(MODULE_NAME)/$(VENDOR_NAME)

#-------------------------------------------------------#
#                       SUBLIBS                         #
#-------------------------------------------------------#

SUBLIBS   =   library

#-------------------------------------------------------#
#                       SUBDIRS                         #
#-------------------------------------------------------#

include $(DIFF_DIR)/subdirs.mk

#-------------------------------------------------------#
#                       TARGETS                         #
#-------------------------------------------------------#
.PHONY:  all libs dirs diff diffi install clean

ifeq ($(_SSL_SUPPORT_), 1)
all: diff link-files libs dirs
else
all: diff libs dirs
endif
	@echo Everything is OK!

libs : ${SUBLIBS}
	@mkdir -p lib
	@for i in ${SUBLIBS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;34m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i || exit 1 ;                                                   \
         done

echo:
	echo ${DIFF_DIR}

dirs : ${SUBDIRS}
	@for i in ${SUBDIRS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;34m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i || exit 1 ;                                                   \
        done

diff:
	make -C $(DIFF_DIR)

diffi:
	make -C $(DIFF_DIR) install
	
link-files:

install: diffi
	@for i in ${SUBLIBS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;35m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i install || exit 1 ;                                           \
        done
	@for i in ${SUBDIRS} ;  do                                                    \
            echo "-----------------------------------------------------------------"; \
            echo -e "\033[;35m                         $$i                 \033[;0m"; \
            echo "-----------------------------------------------------------------"; \
            make -C $$i install || exit 1 ;                                           \
        done

clean:
	for i in ${SUBLIBS} ; do make -C $$i clean || exit 1 ; done
	for i in ${SUBDIRS} ; do make -C $$i clean || exit 1 ; done
#	rm -f lib/*

rami:
	make -C $(DIFF_DIR) rami

=== squashfs-tool/Makefile ===

LZMADIR = ./lzma/compress
INCLUDEDIR = -I. -I$(LZMADIR)

LZMAOBJS = \
	7zapi.o \
        7zlzma.o \
        AriBitCoder.o \
        IInOutStreams.o \
        LenCoder.o \
        LiteralCoder.o \
        LZMA.o \
        LZMAEncoder.o \
        OutByte.o \
        WindowIn.o

CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	else if [ -x /bin/bash ]; then echo /bin/bash; \
	else echo sh; fi ; fi)
TOPDIR	:= $(shell /bin/pwd)

CC = gcc
STRIP = strip

export CC STRIP

#WARNINGS= -Wall

#export DEFS		= -DDEBUG
export CFLAGS		= $(DEFS) $(WARNINGS) -O2 -DGNU $(INCLUDEDIR) -DLZMA_SUPPORT 

vpath %.cpp $(LZMADIR)

all: mksquashfs

mksquashfs:  squashfs/*.c squashfs/*.h $(LZMAOBJS)
	@if [ ! -e /usr/include/zlib.h ]; then \
          echo *****You need to install zlib-devel package to build mksquashfs! ; \
          echo *****You may find it in your Linux distribution CDs. ; \
	  exit ;\
        fi
	gcc $(CFLAGS) -Isquashfs -c squashfs/*.c
	g++  -o mksquashfs mksquashfs.o read_fs.o sort.o $(LZMAOBJS) -lz

$(LZMAOBJS): %.o: %.cpp
	g++ -c $(CFLAGS) $^ -o $@

clean:
	rm -f mksquashfs
	rm -fr *.o core
	rm -fr $(LZMADIR)/*.o

=== uboot/Makefile ===
#
# (C) Copyright 2000-2004
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#
# See file CREDITS for list of people who contributed to this
# project.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#
#
HOSTARCH := $(shell uname -m | \
	sed -e s/i.86/i386/ \
	    -e s/sun4u/sparc64/ \
	    -e s/arm.*/arm/ \
	    -e s/sa110/arm/ \
	    -e s/powerpc/ppc/ \
	    -e s/macppc/ppc/)

HOSTOS := $(shell uname -s | tr A-Z a-z | \
	    sed -e 's/\(cygwin\).*/cygwin/')

export	HOSTARCH

# Deal with colliding definitions from tcsh etc.
VENDOR=

#########################################################################

TOPDIR	:= $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)
export	TOPDIR
ifeq (include/config.mk,$(wildcard include/config.mk))
# load ARCH, BOARD, and CPU configuration
include include/config.mk
export	ARCH CPU BOARD VENDOR
# load other configuration
include $(TOPDIR)/config.mk

ifndef CROSS_COMPILE
ifeq ($(HOSTARCH),ppc)
CROSS_COMPILE =
else
ifeq ($(ARCH),ppc)
CROSS_COMPILE = ppc_8xx-
endif
ifeq ($(ARCH),arm)
ifeq ($(CROSS),armlinux)
CROSS_COMPILE = arm-linux-
endif
endif
ifeq ($(ARCH),i386)
ifeq ($(HOSTARCH),i386)
CROSS_COMPILE =
else
CROSS_COMPILE = i386-linux-
endif
endif
ifeq ($(ARCH),mips)
CROSS_COMPILE = mips_4KC-
endif
ifeq ($(ARCH),nios)
CROSS_COMPILE = nios-elf-
endif
ifeq ($(ARCH),m68k)
CROSS_COMPILE = m68k-elf-
endif
ifeq ($(ARCH),microblaze)
CROSS_COMPILE = mb-
endif
endif
endif

export	CROSS_COMPILE

#########################################################################
# U-Boot objects....order is important (i.e. start must be first)

OBJS  = cpu/$(CPU)/start.o
ifeq ($(CPU),i386)
OBJS += cpu/$(CPU)/start16.o
OBJS += cpu/$(CPU)/reset.o
endif
ifeq ($(CPU),ppc4xx)
OBJS += cpu/$(CPU)/resetvec.o
endif
ifeq ($(CPU),mpc85xx)
OBJS += cpu/$(CPU)/resetvec.o
endif

LIBS  = lib_generic/libgeneric.a
LIBS += board/$(BOARDDIR)/lib$(BOARD).a
LIBS += cpu/$(CPU)/lib$(CPU).a
LIBS += lib_$(ARCH)/lib$(ARCH).a
LIBS += fs/cramfs/libcramfs.a fs/fat/libfat.a fs/fdos/libfdos.a fs/jffs2/libjffs2.a \
	fs/reiserfs/libreiserfs.a fs/ext2/libext2fs.a
LIBS += net/libnet.a
LIBS += disk/libdisk.a
LIBS += rtc/librtc.a
LIBS += dtt/libdtt.a
LIBS += drivers/libdrivers.a
LIBS += drivers/sk98lin/libsk98lin.a
LIBS += post/libpost.a post/cpu/libcpu.a
LIBS += common/libcommon.a
.PHONY : $(LIBS)

# Add GCC lib
PLATFORM_LIBS += --no-warn-mismatch -L $(shell dirname `$(CC) $(CFLAGS) -print-libgcc-file-name`) -lgcc


# The "tools" are needed early, so put this first
# Don't include stuff already done in $(LIBS)
	  #examples \
	  #
SUBDIRS	= tools \
	  post \
	  post/cpu
.PHONY : $(SUBDIRS)

#########################################################################
#########################################################################

ALL = u-boot.srec u-boot.bin System.map

all:		$(ALL)

u-boot.srec:	u-boot
		$(OBJCOPY) ${OBJCFLAGS} -O srec $< $@

u-boot.bin:	u-boot
		$(OBJCOPY) ${OBJCFLAGS} -O binary $< $@

u-boot.img:	u-boot.bin
		./tools/mkimage -A $(ARCH) -T firmware -C none \
		-a $(TEXT_BASE) -e 0 \
		-n $(shell sed -n -e 's/.*U_BOOT_VERSION//p' include/version.h | \
			sed -e 's/"[	 ]*$$/ for $(BOARD) board"/') \
		-d $< $@

u-boot.dis:	u-boot
		$(OBJDUMP) -d $< > $@

		
nboot:          $(NAND_OBJS)
		$(LD) $(NAND_LDFLAGS) $(NAND_OBJS) --start-group $(LIBS) $(PLATFORM_LIBS) --end-group\
		-e nbootStart -Map nboot.map -o nboot
		$(OBJCOPY) ${OBJCFLAGS} -O binary $@ $@.bin
		$(OBJDUMP) -d $@ > $@.dis

cnboot:		
		rm -f nboot*		

u-boot:		depend $(SUBDIRS) $(OBJS) $(LIBS) $(LDSCRIPT)
		UNDEF_SYM=`$(OBJDUMP) -x $(LIBS) |sed  -n -e 's/.*\(__u_boot_cmd_.*\)/-u\1/p'|sort|uniq`;\
		$(LD) $(LDFLAGS) $$UNDEF_SYM $(OBJS) \
			--start-group $(LIBS) $(PLATFORM_LIBS) --end-group \
			-Map u-boot.map -o u-boot

$(LIBS):
		$(MAKE) -C `dirname $@`

$(SUBDIRS):
		$(MAKE) -C $@ all

gdbtools:
		$(MAKE) -C tools/gdb || exit 1

depend dep:
		@for dir in $(SUBDIRS) ; do $(MAKE) -C $$dir .depend ; done

tags:
		ctags -w `find $(SUBDIRS) include \
				lib_generic board/$(BOARDDIR) cpu/$(CPU) lib_$(ARCH) \
				fs/cramfs fs/fat fs/fdos fs/jffs2 fs/ext2\
				net disk rtc dtt drivers drivers/sk98lin common \
			\( -name CVS -prune \) -o \( -name '*.[ch]' -print \)`

etags:
		etags -a `find $(SUBDIRS) include \
			\( -name CVS -prune \) -o \( -name '*.[ch]' -print \)`

System.map:	u-boot
		@$(NM) $< | \
		grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
		sort > System.map

#########################################################################
else
all install u-boot u-boot.srec depend dep:
	@echo "System not configured - see README" >&2
	@ exit 1
endif

#########################################################################

unconfig:
	@rm -f include/config.h include/config.mk board/*/config.tmp

#========================================================================
# PowerPC
#========================================================================

#########################################################################
## MPC5xx Systems
#########################################################################

cmi_mpc5xx_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc5xx cmi

PATI_config:		unconfig
	@./mkconfig $(@:_config=) ppc mpc5xx pati mpl

#########################################################################
## MPC5xxx Systems
#########################################################################
Lite5200_config				\
Lite5200_LOWBOOT_config			\
Lite5200_LOWBOOT08_config		\
icecube_5200_config			\
icecube_5200_LOWBOOT_config		\
icecube_5200_LOWBOOT08_config		\
icecube_5200_DDR_config 		\
icecube_5200_DDR_LOWBOOT_config 	\
icecube_5200_DDR_LOWBOOT08_config	\
icecube_5100_config:			unconfig
	@ >include/config.h
	@[ -z "$(findstring LOWBOOT_,$@)" ] || \
		{ if [ "$(findstring DDR,$@)" ] ; \
			then echo "TEXT_BASE = 0xFF800000" >board/icecube/config.tmp ; \
			else echo "TEXT_BASE = 0xFF000000" >board/icecube/config.tmp ; \
		  fi ; \
		  echo "... with LOWBOOT configuration" ; \
		}
	@[ -z "$(findstring LOWBOOT08,$@)" ] || \
		{ echo "TEXT_BASE = 0xFF800000" >board/icecube/config.tmp ; \
		  echo "... with 8 MB flash only" ; \
		  echo "... with LOWBOOT configuration" ; \
		}
	@[ -z "$(findstring DDR,$@)" ] || \
		{ echo "#define CONFIG_MPC5200_DDR"	>>include/config.h ; \
		  echo "... DDR memory revision" ; \
		}
	@[ -z "$(findstring 5200,$@)" ] || \
		{ echo "#define CONFIG_MPC5200"		>>include/config.h ; \
		  echo "... with MPC5200 processor" ; \
		}
	@[ -z "$(findstring 5100,$@)" ] || \
		{ echo "#define CONFIG_MGT5100"		>>include/config.h ; \
		  echo "... with MGT5100 processor" ; \
		}
	@./mkconfig -a IceCube ppc mpc5xxx icecube

MINI5200_config	\
EVAL5200_config	\
TOP5200_config:	unconfig
	@ echo "#define CONFIG_$(@:_config=) 1"	>include/config.h
	@./mkconfig -a TOP5200 ppc mpc5xxx top5200 emk

PM520_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc5xxx pm520

#########################################################################
## MPC8xx Systems
#########################################################################

AdderII_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx adderII

ADS860_config     \
DUET_ADS_config   \
FADS823_config    \
FADS850SAR_config \
MPC86xADS_config  \
FADS860T_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx fads

AMX860_config	:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx amx860 westel

c2mon_config:		unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx c2mon

CCM_config:		unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx CCM siemens

cogent_mpc8xx_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx cogent

ELPT860_config:		unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx elpt860 LEOX

ESTEEM192E_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx esteem192e

ETX094_config	:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx etx094

FLAGADM_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx flagadm

xtract_GEN860T = $(subst _SC,,$(subst _config,,$1))

GEN860T_SC_config	\
GEN860T_config: unconfig
	@ >include/config.h
	@[ -z "$(findstring _SC,$@)" ] || \
		{ echo "#define CONFIG_SC" >>include/config.h ; \
		  echo "With reduced H/W feature set (SC)..." ; \
		}
	@./mkconfig -a $(call xtract_GEN860T,$@) ppc mpc8xx gen860t

GENIETV_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx genietv

GTH_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx gth

hermes_config	:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx hermes

HMI10_config	:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx tqm8xx

IAD210_config: unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx IAD210 siemens

xtract_ICU862 = $(subst _100MHz,,$(subst _config,,$1))

ICU862_100MHz_config	\
ICU862_config: unconfig
	@ >include/config.h
	@[ -z "$(findstring _100MHz,$@)" ] || \
		{ echo "#define CONFIG_100MHz"	>>include/config.h ; \
		  echo "... with 100MHz system clock" ; \
		}
	@./mkconfig -a $(call xtract_ICU862,$@) ppc mpc8xx icu862

IP860_config	:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx ip860

IVML24_256_config \
IVML24_128_config \
IVML24_config:	unconfig
	@ >include/config.h
	@[ -z "$(findstring IVML24_config,$@)" ] || \
		 { echo "#define CONFIG_IVML24_16M"	>>include/config.h ; \
		 }
	@[ -z "$(findstring IVML24_128_config,$@)" ] || \
		 { echo "#define CONFIG_IVML24_32M"	>>include/config.h ; \
		 }
	@[ -z "$(findstring IVML24_256_config,$@)" ] || \
		 { echo "#define CONFIG_IVML24_64M"	>>include/config.h ; \
		 }
	@./mkconfig -a IVML24 ppc mpc8xx ivm

IVMS8_256_config \
IVMS8_128_config \
IVMS8_config:	unconfig
	@ >include/config.h
	@[ -z "$(findstring IVMS8_config,$@)" ] || \
		 { echo "#define CONFIG_IVMS8_16M"	>>include/config.h ; \
		 }
	@[ -z "$(findstring IVMS8_128_config,$@)" ] || \
		 { echo "#define CONFIG_IVMS8_32M"	>>include/config.h ; \
		 }
	@[ -z "$(findstring IVMS8_256_config,$@)" ] || \
		 { echo "#define CONFIG_IVMS8_64M"	>>include/config.h ; \
		 }
	@./mkconfig -a IVMS8 ppc mpc8xx ivm

KUP4K_config	:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx kup4k kup

KUP4X_config    :       unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx kup4x kup

LANTEC_config	:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx lantec

lwmon_config:		unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx lwmon

MBX_config	\
MBX860T_config:	unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx mbx8xx

MHPC_config:		unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx mhpc eltec

MVS1_config :		unconfig
	@./mkconfig $(@:_config=) ppc mpc8xx mvs1

xtract_NETVIA = $(subst _V2,,$(subst _config,,$1))

NETVIA_V2_config \
NETVIA_config:		unconfig
	@ >include/config.h
	@[ -z "$(findstring NETVIA_config,$@)" ] || \
		 { echo "#define CONFIG_NETVIA_VERSION 1" >>include/config.h ; \
		  echo "... Version 1" ; \
		 }
	@[ -z "$(findstring NETVIA_V2_config,$@)" ] || \
		 { echo "#define CONFIG_NETVIA_VERSION 2" >>include/config.h ; \
		  echo "... Version 2" ; \
		 }
	@./mkconfig -a $(call xtract_NETVIA,$@) ppc mpc8xx netvia

xtract_NETPHONE = $(subst _V2,,$(subst _config,,$1))

NETPHONE_V2_config \
NETPHONE_config:	unconfig
	@ >include/config.h
	@[ -z "$(findstring NETPHONE_config,$@)" ] || \
		 { echo "#define CONFIG_NETPHONE_VERSION 1" >>include/config.h ; \
		 }
	@[ -z "$(findstring NETPHONE_V2_config,$@)" ] || \
		 { echo "#define CONFIG_NETPHONE_VERSION 2" >>include/config.h ; \
		 }

=== linux-2.6.12/crypto/Makefile ===
#
# Cryptographic API
#

proc-crypto-$(CONFIG_PROC_FS) = proc.o

obj-$(CONFIG_CRYPTO) += api.o scatterwalk.o cipher.o digest.o compress.o \
			$(proc-crypto-y)

obj-$(CONFIG_CRYPTO_HMAC) += hmac.o
obj-$(CONFIG_CRYPTO_NULL) += crypto_null.o
obj-$(CONFIG_CRYPTO_MD4) += md4.o
obj-$(CONFIG_CRYPTO_MD5) += md5.o
obj-$(CONFIG_CRYPTO_SHA1) += sha1.o
obj-$(CONFIG_CRYPTO_SHA256) += sha256.o
obj-$(CONFIG_CRYPTO_SHA512) += sha512.o
obj-$(CONFIG_CRYPTO_WP512) += wp512.o
obj-$(CONFIG_CRYPTO_TGR192) += tgr192.o
obj-$(CONFIG_CRYPTO_DES) += des.o
obj-$(CONFIG_CRYPTO_BLOWFISH) += blowfish.o
obj-$(CONFIG_CRYPTO_TWOFISH) += twofish.o
obj-$(CONFIG_CRYPTO_SERPENT) += serpent.o
obj-$(CONFIG_CRYPTO_AES) += aes.o
obj-$(CONFIG_CRYPTO_CAST5) += cast5.o
obj-$(CONFIG_CRYPTO_CAST6) += cast6.o
obj-$(CONFIG_CRYPTO_ARC4) += arc4.o
obj-$(CONFIG_CRYPTO_TEA) += tea.o
obj-$(CONFIG_CRYPTO_KHAZAD) += khazad.o
obj-$(CONFIG_CRYPTO_ANUBIS) += anubis.o
obj-$(CONFIG_CRYPTO_DEFLATE) += deflate.o
obj-$(CONFIG_CRYPTO_MICHAEL_MIC) += michael_mic.o
obj-$(CONFIG_CRYPTO_CRC32C) += crc32c.o

obj-$(CONFIG_CRYPTO_TEST) += tcrypt.o

obj-$(CONFIG_OCF_OCF) += ocf/

=== linux-2.6.12/fs/Makefile ===
#
# Makefile for the Linux filesystems.
#
# 14 Sep 2000, Christoph Hellwig <hch@infradead.org>
# Rewritten to use lists instead of if-statements.
# 

obj-y :=	open.o read_write.o file_table.o buffer.o  bio.o super.o \
		block_dev.o char_dev.o stat.o exec.o pipe.o namei.o fcntl.o \
		ioctl.o readdir.o select.o fifo.o locks.o dcache.o inode.o \
		attr.o bad_inode.o file.o filesystems.o namespace.o aio.o \
		seq_file.o xattr.o libfs.o fs-writeback.o mpage.o direct-io.o \

obj-$(CONFIG_INOTIFY)		+= inotify.o
obj-$(CONFIG_EPOLL)		+= eventpoll.o
obj-$(CONFIG_COMPAT)		+= compat.o

nfsd-$(CONFIG_NFSD)		:= nfsctl.o
obj-y				+= $(nfsd-y) $(nfsd-m)

obj-$(CONFIG_BINFMT_AOUT)	+= binfmt_aout.o
obj-$(CONFIG_BINFMT_EM86)	+= binfmt_em86.o
obj-$(CONFIG_BINFMT_MISC)	+= binfmt_misc.o

# binfmt_script is always there
obj-y				+= binfmt_script.o

obj-$(CONFIG_BINFMT_ELF)	+= binfmt_elf.o
obj-$(CONFIG_BINFMT_ELF_FDPIC)	+= binfmt_elf_fdpic.o
obj-$(CONFIG_BINFMT_SOM)	+= binfmt_som.o
obj-$(CONFIG_BINFMT_FLAT)	+= binfmt_flat.o

obj-$(CONFIG_FS_MBCACHE)	+= mbcache.o
obj-$(CONFIG_FS_POSIX_ACL)	+= posix_acl.o xattr_acl.o

obj-$(CONFIG_QUOTA)		+= dquot.o
obj-$(CONFIG_QFMT_V1)		+= quota_v1.o
obj-$(CONFIG_QFMT_V2)		+= quota_v2.o
obj-$(CONFIG_QUOTACTL)		+= quota.o

obj-$(CONFIG_DNOTIFY)		+= dnotify.o

obj-$(CONFIG_PROC_FS)		+= proc/
obj-y				+= partitions/
obj-$(CONFIG_SYSFS)		+= sysfs/
obj-y				+= devpts/

obj-$(CONFIG_PROFILING)		+= dcookies.o
 
# Do not add any filesystems before this line
obj-$(CONFIG_REISERFS_FS)	+= reiserfs/
obj-$(CONFIG_EXT3_FS)		+= ext3/ # Before ext2 so root fs can be ext3
obj-$(CONFIG_JBD)		+= jbd/
obj-$(CONFIG_EXT2_FS)		+= ext2/
obj-$(CONFIG_CRAMFS)		+= cramfs/
obj-$(CONFIG_SQUASHFS)		+= squashfs/
obj-$(CONFIG_RAMFS)		+= ramfs/
obj-$(CONFIG_HUGETLBFS)		+= hugetlbfs/
obj-$(CONFIG_CODA_FS)		+= coda/
obj-$(CONFIG_MINIX_FS)		+= minix/
obj-$(CONFIG_FAT_FS)		+= fat/
obj-$(CONFIG_MSDOS_FS)		+= msdos/
obj-$(CONFIG_VFAT_FS)		+= vfat/
obj-$(CONFIG_BFS_FS)		+= bfs/
obj-$(CONFIG_ISO9660_FS)	+= isofs/
obj-$(CONFIG_DEVFS_FS)		+= devfs/
obj-$(CONFIG_HFSPLUS_FS)	+= hfsplus/ # Before hfs to find wrapped HFS+
obj-$(CONFIG_HFS_FS)		+= hfs/
obj-$(CONFIG_VXFS_FS)		+= freevxfs/
obj-$(CONFIG_NFS_FS)		+= nfs/
obj-$(CONFIG_EXPORTFS)		+= exportfs/
obj-$(CONFIG_NFSD)		+= nfsd/
obj-$(CONFIG_LOCKD)		+= lockd/
obj-$(CONFIG_NLS)		+= nls/
obj-$(CONFIG_SYSV_FS)		+= sysv/
obj-$(CONFIG_SMB_FS)		+= smbfs/
obj-$(CONFIG_CIFS)		+= cifs/
obj-$(CONFIG_NCP_FS)		+= ncpfs/
obj-$(CONFIG_HPFS_FS)		+= hpfs/
obj-$(CONFIG_NTFS_FS)		+= ntfs/
obj-$(CONFIG_UFS_FS)		+= ufs/
obj-$(CONFIG_EFS_FS)		+= efs/
obj-$(CONFIG_JFFS_FS)		+= jffs/
obj-$(CONFIG_JFFS2_FS)		+= jffs2/
obj-$(CONFIG_AFFS_FS)		+= affs/
obj-$(CONFIG_ROMFS_FS)		+= romfs/
obj-$(CONFIG_QNX4FS_FS)		+= qnx4/
obj-$(CONFIG_AUTOFS_FS)		+= autofs/
obj-$(CONFIG_AUTOFS4_FS)	+= autofs4/
obj-$(CONFIG_ADFS_FS)		+= adfs/
obj-$(CONFIG_UDF_FS)		+= udf/
obj-$(CONFIG_SUN_OPENPROMFS)	+= openpromfs/
obj-$(CONFIG_JFS_FS)		+= jfs/
obj-$(CONFIG_XFS_FS)		+= xfs/
obj-$(CONFIG_AFS_FS)		+= afs/
obj-$(CONFIG_BEFS_FS)		+= befs/
obj-$(CONFIG_HOSTFS)		+= hostfs/
obj-$(CONFIG_HPPFS)		+= hppfs/
obj-$(CONFIG_DEBUG_FS)		+= debugfs/

=== linux-2.6.12/lib/Makefile ===
#
# Makefile for some libs needed in the kernel.
#

lib-y := errno.o ctype.o string.o vsprintf.o cmdline.o \
	 bust_spinlocks.o rbtree.o radix-tree.o dump_stack.o \
	 kobject.o kref.o idr.o div64.o int_sqrt.o \
	 bitmap.o extable.o kobject_uevent.o prio_tree.o sha1.o \
	 halfmd4.o

obj-y += sort.o parser.o

ifeq ($(CONFIG_DEBUG_KOBJECT),y)
CFLAGS_kobject.o += -DDEBUG
CFLAGS_kobject_uevent.o += -DDEBUG
endif

lib-$(CONFIG_RWSEM_GENERIC_SPINLOCK) += rwsem-spinlock.o
lib-$(CONFIG_RWSEM_XCHGADD_ALGORITHM) += rwsem.o
lib-$(CONFIG_GENERIC_FIND_NEXT_BIT) += find_next_bit.o
obj-$(CONFIG_LOCK_KERNEL) += kernel_lock.o

ifneq ($(CONFIG_HAVE_DEC_LOCK),y) 
  lib-y += dec_and_lock.o
endif

obj-$(CONFIG_CRC_CCITT)	+= crc-ccitt.o
obj-$(CONFIG_CRC32)	+= crc32.o
obj-$(CONFIG_LIBCRC32C)	+= libcrc32c.o
obj-$(CONFIG_GENERIC_IOMAP) += iomap.o

obj-$(CONFIG_ZLIB_INFLATE) += zlib_inflate/
obj-$(CONFIG_ZLIB_DEFLATE) += zlib_deflate/
obj-$(CONFIG_LZMA_FS_INFLATE) += inflate_lzma/
obj-$(CONFIG_REED_SOLOMON) += reed_solomon/

hostprogs-y	:= gen_crc32table
clean-files	:= crc32table.h

$(obj)/crc32.o: $(obj)/crc32table.h

quiet_cmd_crc32 = GEN     $@
      cmd_crc32 = $< > $@

$(obj)/crc32table.h: $(obj)/gen_crc32table
	$(call cmd,crc32)

=== linux-2.6.12/mv_usb_gadget/Makefile ===

# kernel sources
ifndef KSRC
KSRC  := .
endif

TOPDIR := $(KSRC)

ifeq ($(CONFIG_ARM),y)
MV_DIR = $(TOPDIR)/arch/arm/mach-mv88fxx81
USB_API_DIR := $(MV_DIR)/Soc/usb
USB_PRV_DIR := $(MV_DIR)/Soc/usb_restricted
include $(MV_DIR)/mv88f5181/mvRules.mk
endif 

ifeq ($(CONFIG_PPC),y)
MV_DIR = $(TOPDIR)/arch/ppc/platforms/Marvell
USB_API_DIR := $(MV_DIR)/Controller/usb
USB_PRV_DIR := $(MV_DIR)/Controller/usb_restricted
include $(MV_DIR)/db645xx/mvRules.make
endif 


USB_DEV_DIR := $(USB_PRV_DIR)/device

CFLAGS  += $(EXTRA_CFLAGS) -I$(USB_API_DIR)/api -I$(USB_PRV_DIR)/common -I$(USB_DEV_DIR)

OBJS        := mv_gadget.o ../$(USB_DEV_DIR)/mvUsbDevCh9.o ../$(USB_DEV_DIR)/mvUsbDevMain.o 	\
               ../$(USB_DEV_DIR)/mvUsbDevRecv.o ../$(USB_DEV_DIR)/mvUsbDevSend.o ../$(USB_DEV_DIR)/mvUsbDevUtl.o 	\
	       ../$(USB_DEV_DIR)/mvUsbHsDevUtl.o  ../$(USB_DEV_DIR)/mvUsbHsDevMain.o ../$(USB_DEV_DIR)/mvUsbHsDevCncl.o

mv_usb_gadget-objs := $(OBJS)
obj-m := mv_usb_gadget.o

=== linux-2.6.12/tools/Makefile ===
# kernel sources 
TOPDIR  := $(shell /bin/pwd)

ifndef KSRC
KSRC  := $(TOPDIR)/..
endif

include $(KSRC)/.config

CC := arm-none-linux-gnueabi-gcc
LD := arm-none-linux-gnueabi-ld

CFLAGS  := $(EXTRA_CFLAGS)
CFLAGS  += -I$(KSRC)/arch/arm/mach-mv88fxx81/LSP/cesa/ 

SUBDIRS=egigatool	 
TARGETS=mv_shell testusb
ifeq ($(CONFIG_MV_CESA),y)
TARGETS += mv_cesa_tool
endif
ifeq ($(CONFIG_MV_PHONE),y)
TARGETS += mv_voip_tool
endif


all : Makefile $(TARGETS)
	@for subdir in $(SUBDIRS); do \
                (cd $$subdir && $(MAKE) $@) || exit 1; \
        done
	
mv_shell : MV_shell.c 
	$(CC) $(CFLAGS) MV_shell.c -o MV_shell

mv_voip_tool: mv_voip_tool.c
	$(CC) $(CFLAGS) mv_voip_tool.c -o mv_voip_tool

mv_cesa_tool:mv_cesa_tool.c
	$(CC) $(CFLAGS) mv_cesa_tool.c -o mv_cesa_tool

testusb: testusb.c
	$(CC) $(CFLAGS) testusb.c -o testusb -lpthread

clean:
	rm -f MV_shell mv_cesa_tool mv_voip_tool testusb *.o
	@for subdir in $(SUBDIRS); do \
                (cd $$subdir && $(MAKE) $@) || exit 1; \
        done

=== source/LVM2.2.02.07/Makefile ===
#
# Copyright (C) 2001-2004 Sistina Software, Inc. All rights reserved.
# Copyright (C) 2004 Red Hat, Inc. All rights reserved.
#
# This file is part of the LVM2.
#
# This copyrighted material is made available to anyone wishing to use,
# modify, copy, or redistribute it subject to the terms and conditions
# of the GNU General Public License v.2.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#---------------------------------------------------
TOPDIR :=  $(shell pwd)
#DESTDIR := $(TOPDIR)/_install
#export	DESTDIR
TOPDIR :=  $(TOPDIR)/..

include $(TOPDIR)/prerules.mk
export COMM_INC_PATH COMM_LIB_PATH
#---------------------------------------------------

srcdir = .
top_srcdir = .


SUBDIRS = include #man 

ifeq ("no", "yes")
  SUBDIRS += po
endif

SUBDIRS += lib tools daemons

ifeq ("", "yes")
  SUBDIRS += dmeventd
endif

ifeq ($(MAKECMDGOALS),distclean)
  SUBDIRS += daemons/clvmd \
	     dmeventd \
	     lib/format1 \
	     lib/format_pool \
	     lib/locking \
	     lib/mirror \
	     lib/snapshot \
	     po \
	     test/mm test/device test/format1 test/regex test/filters
  DISTCLEAN_TARGETS += lib/misc/configure.h
endif

include make.tmpl

daemons: lib
lib: include
tools: lib
dmeventd: tools
po: tools daemons dmeventd

ifeq ("no", "yes")
lib.pofile: include.pofile
tools.pofile: lib.pofile
daemons.pofile: lib.pofile
dmeventd.pofile: tools.pofile
po.pofile: tools.pofile daemons.pofile dmeventd.pofile
pofile: po.pofile
endif

ifneq ("", "")
tools.cflow: lib.cflow
cflow: tools.cflow
endif

ifneq ("", "")
cscope.out: tools
	 -b -R
all: cscope.out
endif

=== source/ample-0.5.7/Makefile ===
# Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.

all:
	$(MAKE) -C src

install: all
	$(MAKE) -C src install
clean:
	$(MAKE) -C src clean

.PHONY: all clean install

# Tell versions [3.59,3.63) of GNU make to not export all variables.
# Otherwise a system limit (for SysV at least) may be exceeded.

=== source/devmapper-1.02.07/debian/changelog ===
devmapper (2:1.02.07-1) unstable; urgency=low

  * New upstream version.
  * Update priorities to match overrides.
  * Acknowledge NMU. (closes: #316883, #329409, #341901, #342455)

 -- Bastian Blank <waldi@debian.org>  Sat, 10 Jun 2006 21:20:43 +0000

devmapper (2:1.02.05-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Set default device modes to 0, 6, 0660, according to the decision
    of the technical committee,
    http://lists.debian.org/debian-ctte/2006/04/msg00033.html
    Closes: #316883, #329409, #341901, #342455
    LVM devices are created with root:disk ownership and 0660 permissions,
    which is used by all other disk block devices.  This allows backups
    of LVM logical volumes with tools such as amanda, which run as user
    backup, a member of the disk group.
    Thanks for Roger Leigh for preparing the patch.

 -- Andreas Barth <aba@not.so.argh.org>  Sun,  4 Jun 2006 20:15:33 +0200

devmapper (2:1.02.05-2) unstable; urgency=low

  * Generate udeb shlibs entries. (closes: #356906)
  * Set default device modes to 0, 6, 0644. (closes: #304476)

 -- Bastian Blank <waldi@debian.org>  Sat, 13 May 2006 14:44:47 +0000

devmapper (2:1.02.05-1) unstable; urgency=low

  * New upstram version.
  * Install pkgconfig file. (closes: #355927)

 -- Bastian Blank <waldi@debian.org>  Fri,  5 May 2006 20:40:42 +0000

devmapper (2:1.02.03-1) unstable; urgency=low

  * New upstram version. 
  * Make device modes overridable.

 -- Bastian Blank <waldi@debian.org>  Sun, 12 Feb 2006 11:45:49 +0100

devmapper (2:1.02.02-1) unstable; urgency=low

  * New upstram version. 
    - Use names instead of numbers in messages when ioctls fail.
      (closes: #341452)

 -- Bastian Blank <waldi@debian.org>  Fri, 02 Dec 2005 20:16:55 +0100

devmapper (2:1.02.00-1) unstable; urgency=low

  * New upstream version. (closes: #338947)

 -- Bastian Blank <waldi@debian.org>  Thu, 24 Nov 2005 20:07:41 +0100

devmapper (2:1.01.05-1) unstable; urgency=low

  * Readd init script to load the device-mapper module.
    (closes: #330549, #315161, #298406)

 -- Bastian Blank <waldi@debian.org>  Thu, 29 Sep 2005 18:58:31 +0200

devmapper (2:1.01.04-2) unstable; urgency=low

  * Enable selinux support for debs. (closes: #323022)
  * Change optimization for udebs. (closes: #314360)

 -- Bastian Blank <waldi@debian.org>  Sun, 14 Aug 2005 11:14:54 +0200

devmapper (2:1.01.04-1) unstable; urgency=low

  * New upstream version.
  * Explicitly disable selinux support. (blocked by #322891)

 -- Bastian Blank <waldi@debian.org>  Sat, 13 Aug 2005 13:16:31 +0200

devmapper (2:1.01.03-1) unstable; urgency=low

  * New upstream version.
  * Remove init script, libdevmapper creates the device themself.

 -- Bastian Blank <waldi@debian.org>  Sun, 19 Jun 2005 13:41:08 +0200

devmapper (2:1.01.00-4) unstable; urgency=low

  * Build static libs.
  * Remove the wrong dh_python call.

 -- Bastian Blank <waldi@debian.org>  Mon, 14 Mar 2005 19:43:32 +0100

devmapper (2:1.01.00-3) unstable; urgency=low

  * Don't longer use cdbs.
  * Remove many cruft.

 -- Bastian Blank <waldi@debian.org>  Mon, 14 Mar 2005 13:55:47 +0100

devmapper (2:1.01.00-2) unstable; urgency=high

  * New maintainer.
  * Fix initscript links. (closes: #299013)

 -- Bastian Blank <waldi@debian.org>  Fri, 11 Mar 2005 08:29:31 +0100

devmapper (2:1.01.00-1) unstable; urgency=low

  * New upstream
  * Set permission on control device to 0660
    Closes: #294260

 -- Patrick Caulfield <patrick@debian.org>  Mon, 14 Feb 2005 09:20:23 +0000

devmapper (2:1.00.19-4) unstable; urgency=low

  * Cope with single/multiple spaces in "ls" output when checking device.
    Closes: #273273
    
 -- Patrick Caulfield <patrick@debian.org>  Sun, 17 Oct 2004 11:01:00 +0100

devmapper (2:1.00.19-3) unstable; urgency=low

  * Remove kernel-patch-devmapper as it is now incorporated in the
    Debian kernel.
    Closes: #262347, #272384
  * Remove XSI:ism (what ever that is) from init script.
    Closes: #258853 
  
 -- Patrick Caulfield <patrick@debian.org>  Mon, 20 Sep 2004 08:01:42 +0100

devmapper (2:1.00.19-2) unstable; urgency=low

  * Don't error on startup of /dev/mapper directory does not exist.
    Closes: #259314

 -- Patrick Caulfield <patrick@debian.org>  Thu, 15 Jul 2004 11:52:38 +0100

devmapper (2:1.00.19-1) unstable; urgency=low

  * New upstream version(s). Closes: #257958
  * Don't build debian-speciif patches as dm is now in the Debian kernels
    Closes: #247004, #252168
  * Don't recreate /dev/mapper/control if it hasn't changed.
    Closes: #257106
  * Add dmsetup udeb
    Closes: #241385

 -- Patrick Caulfield <patrick@debian.org>  Wed,  7 Jul 2004 14:42:34 +0100

devmapper (2:1.00.17-5) unstable; urgency=low

  * Take over maintainership.
  * recreate the /dev/mapper/control device at each reboot in case
    the minor number changes. Closes: #236735

 -- Patrick Caulfield <patrick@debian.org>  Tue,  1 Jun 2004 11:13:55 +0100

devmapper (2:1.00.17-4) unstable; urgency=low

  * The DAM-approval-process-sucks release.
  * Fix missing autoconf build-dep (closes: #249476).

 -- Andres Salomon <dilinger@voxel.net>  Mon, 17 May 2004 22:35:26 -0400

devmapper (2:1.00.17-3) unstable; urgency=low

  * Fix autoconf check for selinux build environment (closes: #248656).

 -- Andres Salomon <dilinger@voxel.net>  Mon, 17 May 2004 03:20:52 -0400

devmapper (2:1.00.17-2) unstable; urgency=low

  * Add a little blurb about the removal of VFS locking patch in
    README.Debian.  By popular request.
  * Have libdevmapper1.00-udeb provide libdevmapper1.00 (closes: #248238).

 -- Andres Salomon <dilinger@voxel.net>  Mon, 10 May 2004 02:07:12 -0400

devmapper (2:1.00.17-1) unstable; urgency=low

  * New upstream release.
  * Update kernel patches, ensure VFS lock patch is applied
    (closes: #245748).
  * Move dmsetup binary into /sbin (closes: #247053).
  * Add 002-lfs.patch; compile w/ -D_FILE_OFFSET_BITS=64.



=== source/xfsprogs-2.7.11/debian/changelog ===
xfsprogs (2.7.11-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Mon, 16 Jan 2006 08:38:31 +1100

xfsprogs (2.7.7-1) unstable; urgency=low

  * New upstream release.
  * Add support for (optional) ATTR2 format extension (closes: #336350)
  * Allow gcc -pedantic option for C++ <xfs.h> users (closes: #249429)
  * Fix segv in xfs_db frag command (closes: #338207)

 -- Nathan Scott <nathans@debian.org>  Wed, 16 Nov 2005 16:32:35 +1100

xfsprogs (2.7.4-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Sat, 08 Oct 2005 10:34:10 +1000

xfsprogs (2.6.36-1) unstable; urgency=low

  * New upstream release.
  * Fix xfs_repair secondary SB search 32 bit wrap (closes: #320081)

 -- Nathan Scott <nathans@debian.org>  Thu, 28 Jul 2005 14:01:50 +1000

xfsprogs (2.6.28-1) unstable; urgency=low

  * New upstream release.
  * Fix compilation with gcc version 4 (closes: #300544)

 -- Nathan Scott <nathans@debian.org>  Wed, 30 Mar 2005 10:52:07 +1000

xfsprogs (2.6.26-2) unstable; urgency=low

  * No code differences, recompiled with a more recent gcc version.

 -- Nathan Scott <nathans@debian.org>  Tue, 29 Mar 2005 11:57:57 +1000

xfsprogs (2.6.26-1) unstable; urgency=low

  * New upstream release.
  * Man page updates (closes: #295397)
  * Fix compilation with gcc version 4 (closes: #297876)
  * Switch build dependency from readline4 to readline5.

 -- Nathan Scott <nathans@debian.org>  Tue, 08 Mar 2005 16:56:35 +1100

xfsprogs (2.6.23-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Fri, 17 Sep 2004 17:04:45 +1000

xfsprogs (2.6.21-1) unstable; urgency=low

  * New upstream release.
  * Fix xfs_io build for older glibc versions (current stable).

 -- Nathan Scott <nathans@debian.org>  Mon, 09 Aug 2004 16:09:42 +1000

xfsprogs (2.6.20-1) unstable; urgency=low

  * New upstream release.
  * Fix xfs_io segfault on non-XFS files.  (closes: #260470)
  * Fix packaging botch, deleted files included.  (closes: #260491)

 -- Nathan Scott <nathans@debian.org>  Wed, 28 Jul 2004 21:11:38 +1000

xfsprogs (2.6.19-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Sat, 17 Jul 2004 11:28:39 +1000

xfsprogs (2.6.18-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Fri, 25 Jun 2004 16:57:09 +1000

xfsprogs (2.6.15-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Wed, 09 Jun 2004 21:10:14 +1000

xfsprogs (2.6.14-1) unstable; urgency=low

  * New upstream release.
  * Add a Provides: fsck-backend clause as requested in the context
    of bug number 111651.

 -- Nathan Scott <nathans@debian.org>  Thu, 13 May 2004 09:56:19 +1000

xfsprogs (2.6.11-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Fri, 16 Apr 2004 11:50:56 +1000

xfsprogs (2.6.5-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Thu, 26 Feb 2004 14:44:41 +1100

xfsprogs (2.6.3-1) unstable; urgency=low

  * New upstream release.
  * Add support for debian-installer.  (closes: #225444)
    Author: Steve Langasek.
  * Use debhelper instead of debmake, for proper udeb building.
    Author: Steve Langasek.
  * Drop boot-floppies support.  (closes: #112715)
    Author: Steve Langasek.
  * Add support for the security attribute namespace.

 -- Nathan Scott <nathans@debian.org>  Mon, 19 Jan 2004 10:08:59 +1100

xfsprogs (2.6.0-1) unstable; urgency=low

  * New upstream release.
  * Note: change in the mkfs algorithm for sizing allocation groups.

 -- Nathan Scott <nathans@debian.org>  Tue, 28 Oct 2003 15:23:48 +1100

xfsprogs (2.5.11-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Fri, 10 Oct 2003 09:37:57 +1000

xfsprogs (2.5.6-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Tue, 19 Aug 2003 09:44:48 +1000

xfsprogs (2.5.5-1) unstable; urgency=low

  * New upstream release.

 -- Nathan Scott <nathans@debian.org>  Thu, 07 Aug 2003 12:58:36 +1000

xfsprogs (2.5.4-1) unstable; urgency=low

  * New upstream release, includes xfs_copy command
  * Fix shell quoting in xfs_bmap, from Kai S. Juse (closes: #202588)

 -- Nathan Scott <nathans@debian.org>  Wed, 23 Jul 2003 10:36:28 +1000

xfsprogs (2.5.3-1) unstable; urgency=low

  * New upstream release
  * Changed mkfs.xfs default log size scaling algorithm slightly, to
    create larger logs at smaller filesystem sizes by default
  * Enable support for sector sizes larger than 512 bytes

 -- Nathan Scott <nathans@debian.org>  Mon,  7 Jul 2003 16:06:21 +1000

xfsprogs (2.4.12-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Mon,  2 Jun 2003 13:51:06 +1000

xfsprogs (2.4.10-1) unstable; urgency=low

  * New upstream release
  * Add missing xfslibs-dev dependency on uuid-dev (closes: #193309)

 -- Nathan Scott <nathans@debian.org>  Thu, 15 May 2003 08:50:22 +1000

xfsprogs (2.4.9-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Fri,  2 May 2003 09:34:17 +1000

xfsprogs (2.4.4-1) unstable; urgency=low

  * New upstream release
  * Dependencies on libreadline4 and libreadline4-dev added

 -- Nathan Scott <nathans@debian.org>  Sun, 30 Mar 2003 10:30:18 +1000

xfsprogs (2.4.1-1) unstable; urgency=low

  * New upstream release
  * Updated policy version to which this package conforms
  * Note: unwritten extents are now enabled by default in mkfs.xfs

 -- Nathan Scott <nathans@debian.org>  Tue, 18 Mar 2003 16:16:43 +1100

xfsprogs (2.3.11-1) unstable; urgency=low

  * Add missing build dependency on gettext (closes: #181331)

 -- Nathan Scott <nathans@debian.org>  Tue, 18 Feb 2003 08:57:46 +1100

xfsprogs (2.3.10-1) unstable; urgency=low

  * New upstream release

 -- Nathan Scott <nathans@debian.org>  Mon, 17 Feb 2003 14:52:20 +1100



=== source/devmapper-1.02.07/debian/control ===
Source: devmapper
Section: admin
Priority: optional
Maintainer: Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends: debhelper (>= 5.0.22), autotools-dev, libselinux1-dev
Standards-Version: 3.6.2

Package: libdevmapper-dev
Section: libdevel
Architecture: any
Depends: libdevmapper1.02 (= ${Source-Version})
Description: The Linux Kernel Device Mapper header files
 The Linux Kernel Device Mapper is the LVM (Linux Logical Volume Management)
 Team's implementation of a minimalistic kernel-space driver that handles
 volume management, while keeping knowledge of the underlying device layout
 in user-space.  This makes it useful for not only LVM, but EVMS, software
 raid, and other drivers that create "virtual" block devices.
 .
 This package contains the (user-space) header files for accessing the
 device-mapper; it allow usage of the device-mapper through a clean,
 consistent interface (as opposed to through kernel ioctls).

Package: libdevmapper1.02
Section: libs
Priority: required
Architecture: any
Depends: ${shlibs:Depends}
Provides: libdevmapper
Description: The Linux Kernel Device Mapper userspace library
 The Linux Kernel Device Mapper is the LVM (Linux Logical Volume Management)
 Team's implementation of a minimalistic kernel-space driver that handles
 volume management, while keeping knowledge of the underlying device layout
 in user-space.  This makes it useful for not only LVM, but EVMS, software
 raid, and other drivers that create "virtual" block devices.
 .
 This package contains the (user-space) shared library for accessing the
 device-mapper; it allows usage of the device-mapper through a clean,
 consistent interface (as opposed to through kernel ioctls).

Package: libdevmapper1.02-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}
Provides: libdevmapper1.02
Description: The Linux Kernel Device Mapper userspace library
 This is a udeb, or a microdeb, for the debian-installer.
 .
 The Linux Kernel Device Mapper is the LVM (Linux Logical Volume Management)
 Team's implementation of a minimalistic kernel-space driver that handles
 volume management, while keeping knowledge of the underlying device layout
 in user-space.  This makes it useful for not only LVM, but EVMS, software
 raid, and other drivers that create "virtual" block devices.

Package: dmsetup
Section: admin
Architecture: any
Depends: ${shlibs:Depends}
Description: The Linux Kernel Device Mapper userspace library
 The Linux Kernel Device Mapper is the LVM (Linux Logical Volume Management)
 Team's implementation of a minimalistic kernel-space driver that handles
 volume management, while keeping knowledge of the underlying device layout
 in user-space.  This makes it useful for not only LVM, but EVMS, software
 raid, and other drivers that create "virtual" block devices.
 .
 This package contains a utility for modifying device mappings.

Package: dmsetup-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}
Description: The Linux Kernel Device Mapper userspace library
 The Linux Kernel Device Mapper is the LVM (Linux Logical Volume Management)
 Team's implementation of a minimalistic kernel-space driver that handles
 volume management, while keeping knowledge of the underlying device layout
 in user-space.  This makes it useful for not only LVM, but EVMS, software
 raid, and other drivers that create "virtual" block devices.
 .
 This package contains a utility for modifying device mappings.

=== source/devmapper-1.02.07/debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
export DH_VERBOSE=1

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif

BUILD_DIR = debian/build

PACKAGES_DEB = libdevmapper-dev libdevmapper1.02 dmsetup
PACKAGES_UDEB = libdevmapper1.02-udeb dmsetup-udeb

$(BUILD_DIR)/build-deb/config.status: DIR = $(BUILD_DIR)/build-deb
$(BUILD_DIR)/build-deb/config.status:
	dh_testdir

	rm -rf $(DIR)
	mkdir -p $(DIR)
	cp -al $(filter-out debian, $(wildcard *)) $(DIR)
	cp --remove-destination /usr/share/misc/config.sub /usr/share/misc/config.guess $(DIR)/autoconf
	cd $(DIR); \
	./configure \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--libdir=/lib --sbindir=/sbin \
		--enable-compat \
		--enable-pkgconfig \
		--with-device-uid=0 \
		--with-device-gid=6 \
		--with-device-mode=0660

$(BUILD_DIR)/build-udeb/config.status: DIR = $(BUILD_DIR)/build-udeb
$(BUILD_DIR)/build-udeb/config.status:
	dh_testdir

	rm -rf $(DIR)
	mkdir -p $(DIR)
	cp -al $(filter-out debian, $(wildcard *)) $(DIR)
	cp --remove-destination /usr/share/misc/config.sub /usr/share/misc/config.guess $(DIR)/autoconf
	cd $(DIR); \
	./configure \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--libdir=/lib --sbindir=/sbin \
		--with-optimisation=-Os \
		--enable-compat \
		--disable-selinux

build: build-deb build-udeb

build-deb: $(BUILD_DIR)/build-deb-stamp
$(BUILD_DIR)/build-deb-stamp: DIR = $(BUILD_DIR)/build-deb
$(BUILD_DIR)/build-deb-stamp: $(BUILD_DIR)/build-deb/config.status
	dh_testdir

	$(MAKE) -C $(DIR)

	touch $@

build-udeb: $(BUILD_DIR)/build-udeb-stamp
$(BUILD_DIR)/build-udeb-stamp: DIR = $(BUILD_DIR)/build-udeb
$(BUILD_DIR)/build-udeb-stamp: $(BUILD_DIR)/build-udeb/config.status
	dh_testdir

	$(MAKE) -C $(DIR)

	touch $@

clean:
	dh_testdir
	rm -rf $(BUILD_DIR)

	dh_clean

install: install-deb install-udeb

install-deb: DH_OPTIONS = $(addprefix -p,$(PACKAGES_DEB))
install-deb: DIR = $(BUILD_DIR)/build-deb
install-deb: INSTALL_DIR = $(BUILD_DIR)/install-deb
install-deb: build-deb
	dh_testdir
	dh_testroot
	dh_clean -k $(DH_OPTIONS)

	rm -rf $(INSTALL_DIR)
	$(MAKE) -C $(DIR) install DESTDIR=$(CURDIR)/$(INSTALL_DIR)

	dh_install $(DH_OPTIONS) --sourcedir=$(INSTALL_DIR)

install-udeb: DH_OPTIONS = $(addprefix -p,$(PACKAGES_UDEB))
install-udeb: DIR = $(BUILD_DIR)/build-udeb
install-udeb: INSTALL_DIR = $(BUILD_DIR)/install-udeb
install-udeb: build-udeb
	dh_testdir
	dh_testroot
	dh_clean -k $(DH_OPTIONS)

	rm -rf $(INSTALL_DIR)
	$(MAKE) -C $(DIR) install DESTDIR=$(CURDIR)/$(INSTALL_DIR)

	dh_install $(DH_OPTIONS) --sourcedir=$(INSTALL_DIR)

# Build architecture-independent files here.
binary-indep:

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs WHATS_NEW -a
	dh_installdocs -a
	dh_installinit -a -- start 25 S .
	dh_strip -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a -V 'libdevmapper1.02 (>= 2:1.02.02-2)' --add-udeb 'libdevmapper1.02-udeb'
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
